import java.util.List;
import java.util.LinkedList;
import java.util.HashMap;
import java.util.Iterator;

import java.lang.Integer;

import swarm.Globals;


public class Bar {
  int	attendance;
  int   totalAgents;
 
  MovingAverage myHistory;
    //ModelSwarm  myModelSwarm;
  HashMap rules;

  public Bar (int MAsize){
      myHistory = new MovingAverage(MAsize);
  }


  public void startStep(){
   
    int compareNum = this.getLastAttendance ();
    
    System.out.println("Bar, last attendance was" + compareNum );
    System.out.println("Bar, attendance is " + attendance);

    Rule aRule; 
    Iterator iterator = rules.values().iterator();
    while (iterator.hasNext()){
	aRule = (Rule) iterator.next();
	aRule.wasSuccess (compareNum);
    }
    
    attendance = 0;
    System.out.println(" Bar start step attend = " + attendance);
  }


    public void endStep (){
	System.out.println("Bar end step attend " + attendance);
	myHistory.addValue (attendance);
    }

///////////////////////////////////////////////////////
// agentArriving
// record that an agent is arriving at the bar


    public void agentArriving(int x){
	attendance++;
	System.out.println("Bar: Agent " + x + "attending +1");
    }



    public double getMA (){
	return myHistory.getMA();
    }


/////////////////////////////////////////////////////////
// get/set methods
//      public void setTotalAgents (int x) { totalAgents = x;}

    public int getAttendance() { return attendance; }

    public int getLastAttendance() { 
	return (int) myHistory.getLastNum();
    }

    //previous 2 methods return the same thing if called before 'startStep'

    public void setStartAttendance (int x) { myHistory.addValue(x);}


    public double getAttendanceLag (int x) {
	return myHistory.getInputLag(x);
    }

    public double getRAvgAttendance() {
	return myHistory.getAverage();
    }

    public double getCycle (int repeatTime) {
	return myHistory.getCycle(repeatTime);
    }
    public double getTrendWithBound (int num,int max) {
	return myHistory.getTrendNumWithBound (num, max);
    }

    public double getPartAttendance (int x) {
	return myHistory.getPartAverage( x);
    }

    //    public int getTotalAgents() { return totalAgents; }

    public void setRules (HashMap r) { rules = r; }

    //public void setModelSwarm (ModelSwarm ms) { myModelSwarm = ms; }
}


