import swarm.Globals;
import swarm.defobj.Arguments;
import swarm.defobj.ArgumentsC;
import swarm.defobj.ArgumentsCImpl;
import swarm.defobj.ArgumentsImpl;
import swarm.defobj.Zone;

import java.lang.reflect.*;
import java.awt.*;


public class MyParameter  {
    public int numAgents = 100; 
    public int numActive = 5;
    public int historyLength =20;
    public int startAttendance = 44 ;
    public int run = 1;
    public int experimentDuration = 1000;
    public double seedProb;
    public int unattended = 0;



    public MyParameter (String[] arg){
	int i;
	String argv[] = new String[1 + arg.length];

	argv[0] = "jelfarol";
	for (i = 0; i < arg.length; i++)
	    argv[i+1] = arg[i];

	Arguments arguments;
	ArgumentsC argumentsC = new ArgumentsCImpl ( new ArgumentsImpl() );

	argumentsC.createBegin (Globals.env.globalZone);
	argumentsC.setArgc$Argv (1+arg.length, argv);
	argumentsC.setAppName (argv[0]);
	
	arguments = (Arguments) argumentsC.createEnd();

	showMethods(arguments);

	//	Globals.envC.setArguments (arguments);
	Globals.envC.createEnd ();
	
    }



    
    
    static void showMethods(Object o) {
	Class c = o.getClass();
	Method[] theMethods = c.getMethods();
	for (int i = 0; i < theMethods.length; i++) {
	    String methodString = theMethods[i].getName();
	    System.out.println("Name: " + methodString);
	    String returnString =
		theMethods[i].getReturnType().getName();
	    System.out.println("   Return Type: " + returnString);
	    Class[] parameterTypes = theMethods[i].getParameterTypes();
	    System.out.print("   Parameter Types:");
	    for (int k = 0; k < parameterTypes.length; k ++) {
		String parameterString = parameterTypes[k].getName();
		System.out.print(" " + parameterString);
	    }
	    System.out.println();
	}
    }
    
}
//  + createBegin: aZone
//  {
//    static struct argp_option options[] = {
//      {"inputfile", 'I', "filename",0,"set fn", 5},
//      {"run", 'R', "RunNumber",0,"Run is...",6},
//      {"seedProb",'p',"seedProb",0,"Seed",7},
//      {"worldXSize",'x',"X",0,"Size of X dimension",8},
//      {"worldYSize",'y',"Y",0,"Size of Y dimension",9},
//      {"numActive",'a',"Active",0,"Number of Active Rules",10},
//      {"numAgents",'n',"NA",0,"Number of People",11},
//      {"startAttendance",'S',"SA",0,"Initial number of attendees",12},
//      {"historyLength",'h',"H",0,"History Length",13},
//      {"experimentDuration",'e',"E",0,"Duration of experiment", 14},
//      { 0 }
//    };
//    MyParameter *obj = [super createBegin: aZone];
//    [obj addOptions: options];
  
//  - init
//  {
//    id probeMap;
//    probeMap = [EmptyProbeMap createBegin: [self getZone]];
//    [probeMap setProbedClass: [self class]];
//    probeMap = [probeMap createEnd];
//    //This stuff is taken fromt eh ModelSwarm.m file
//    //Add a bunch of variables, one per simulation parameter.

//    [probeMap addProbe: [probeLibrary getProbeForVariable: "worldXSize"
//  				    inClass:[self class]]];
//    [probeMap addProbe: [probeLibrary getProbeForVariable: "worldYSize"
//  				    inClass:[self class]]];
//    [probeMap addProbe: [probeLibrary getProbeForVariable: "numAgents"
//  				    inClass:[self class]]];
//    [probeMap addProbe: [probeLibrary getProbeForVariable: "startAttendance"
//  				    inClass:[self class]]];
//    [probeMap addProbe: [probeLibrary getProbeForVariable: "numActive"
//  				    inClass:[self class]]];
//    [probeMap addProbe: [probeLibrary getProbeForVariable: "seedProb"
//  				    inClass:[self class]]];
//    [probeMap addProbe: [probeLibrary getProbeForVariable: "experimentDuration"
//  				    inClass:[self class]]];
//    [probeMap addProbe: [probeLibrary getProbeForVariable: "historyLength"
//  				    inClass:[self class]]];

//  //Now install our custom probeMap into the probeLibrary.
 
//  [probeLibrary setProbeMap: probeMap For: [self class]];
//  return self;
//  }

//  - (int)parseKey: (int) key arg: (const char*) arg
//  {
//    //We could just make a list of if statements that checks the argument
//    //to see if it is equal to our parameters, like so:
//    //  if (key == 'd')
//    //      {
//    //          if(arg)
//    //          historyLength = strtod (arg,NULL);
//    //          return 0;
//    //      }
//    //Doing that gets a bit tedious, so we use the switch statement from C:
//    switch(key)
//      {
//      case 'p' :
//        if(arg)
//  	seedProb = strtod (arg,NULL);
//        break;
//      case 'x': 
//        if(arg)
//  	worldXSize = atoi(arg);
//        break;
//      case 'y':
//        if(arg)
//  	worldYSize = atoi(arg);
//        break;
//      case 'e':
//        if(arg)
//  	experimentDuration = atoi(arg);
//        break;
//      case 'h':
//        if(arg)
//  	historyLength = atoi(arg);
//        break;
//      case 't':
//        if(arg)
//  	startAttendance = atoi(arg);
//        break;
//      case 'n':
//        if(arg)
//  	numAgents = atoi(arg);
//        break;
//      case 'a':
//        if(arg)
//  	numActive = atoi(arg);
//        break;
//      case 'I':
//        if(arg)
//  	//You may need this later
//  	break;
//      case 'R':
//        if(arg)
//  	run = atoi(arg);
//        break;
//      default:
//        return [super parseKey: key arg: arg];
//      }
//    return 0;
//  }














